import XCTest
@testable import SwiftBncsLib

class FoundationDataXSha1Tests: XCTestCase {

    func testXSha1() {
        let input = Foundation.Data(bytes: [0x74, 0x68, 0x69, 0x73, 0x20, 0x69, 0x73, 0x20, 0x61, 0x20, 0x74, 0x65, 0x73, 0x74, 0x20, 0x73, 0x74, 0x72, 0x69, 0x6e, 0x67])
        XCTAssertEqual(input.xsha1(), Data([
            0x2D, 0xE1, 0xF7, 0xCE, 0x4A, 0x30, 0x14, 0x85, 0xC5, 0x99, 0x61, 0xE5,
            0x34, 0x8D, 0xC7, 0x17, 0x39, 0x16, 0xCC, 0xBD
        ]))

        let input2 = Foundation.Data(bytes: [0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x30])
        XCTAssertEqual(input2.xsha1(), Data([
            0xB8, 0xFA, 0xF0, 0x99, 0x3E, 0x52, 0xB4, 0xB5, 0xEF, 0xE5, 0x58, 0x0D,
            0x5F, 0xFA, 0x26, 0xE1, 0x4B, 0x3B, 0x63, 0x12
        ]))
    }

}
